SystemOrganization addCategory: #'Orca-Testing'!

OrcaTestCase subclass: #OrcaClientSideTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestCase class methodsFor: 'configuration' stamp: 'sw 5/23/2011 11:23'!
requiredClasses

	^ { OrcaTestResult . OrcaPopup }! !

!OrcaClientSideTestCase class methodsFor: 'configuration' stamp: 'sw 5/10/2011 14:41'!
suiteClass

	 ^ OrcaClientSideTestSuite ! !

!OrcaClientSideTestCase methodsFor: 'accessing' stamp: 'sw 5/23/2011 11:27'!
add: aWidget
	
	aWidget addToWorld ! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'hk 5/17/2011 16:43'!
debug

	Error signal: 'A failure or error occured while testing. See the browser for details.'! !

!OrcaClientSideTestCase methodsFor: 'testing' stamp: 'hk 5/17/2011 16:40'!
document

	^ Js Document! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'sw 5/23/2011 12:58'!
performTest

	^ self perform:  self selector ! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'sw 5/24/2011 08:18'!
run
	
	"this method will be called in the image when executing single tests (e.g. in the class browser when test a method)"
	OrcaClientSideTestRunner ensureClientSideTestRunnerIsStarted.
	OrcaClientSideTestSession allInstances
	select: [ :each | each channel isAlive ]
	thenDo:
		[ :each | 
		
		    [	[ :aDictionary | 
			Js Global testRunner executeTests: aDictionary ] inSession: each values: { {(self class name ->  self selector )} }.
		    ] forkNamed: 'OutGoingTestRequest-KillMe'.
		].
	
	^ OrcaClientSideTestRunner waitForTestsResults! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'sw 5/23/2011 17:28'!
runCase

	| result |
	
	self setUp.
	result := self performTest.
	self tearDown.
	^ result! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'hk 5/17/2011 16:45'!
runOnClientside
	
	| result |
	"this method will be invoked in the client to execute the tests"
	
	result := OrcaTestResult new.
	self run: result.
	^ result! !

!OrcaClientSideTestCase methodsFor: 'accessing' stamp: 'hk 5/17/2011 16:43'!
timeoutForSetUp 

	 ^ 60 * 1000! !

!OrcaClientSideTestCase methodsFor: 'accessing' stamp: 'hk 5/17/2011 16:44'!
timeoutForTest

	 ^ 60 * 1000! !

OrcaClientSideTestCase subclass: #OrcaDemoTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaDemoTests methodsFor: 'testing' stamp: 'sw 5/23/2011 10:56'!
testError

	self fail.! !

!OrcaDemoTests methodsFor: 'testing' stamp: 'sw 5/23/2011 10:56'!
testExpectedError

"	self
		should: [ Foo bar ]
		raise: Error."! !

!OrcaDemoTests methodsFor: 'testing' stamp: 'hk 5/17/2011 16:36'!
testPass
	
	self assert: true.! !

!OrcaDemoTests methodsFor: 'testing' stamp: 'hk 5/17/2011 16:37'!
testSimpleFail

	self assert: false.! !

OrcaClientSideTestCase subclass: #OrcaDomTestCase
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

OrcaDomTestCase subclass: #OrcaDomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaDomTest class methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 09:59'!
cssId

	 ^ 'text'! !

!OrcaDomTest methodsFor: 'running' stamp: 'sw 5/23/2011 17:24'!
setUp

	| widget |
	widget := OrcaText new
		text: 'Hello World';
		cssId: self class cssId.
	widget node name: self class cssId.
	self add: widget ! !

!OrcaDomTest methodsFor: 'running' stamp: 'sw 5/23/2011 17:25'!
tearDown
	
	| |
	
	"self halt.
	
	element := Js document getElementById value: self class cssId.
	Js document body removeChild value: element."! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/17/2011 16:52'!
testElementPresence

	self assert: (self hasElement: 'span').! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/18/2011 11:41'!
testId

	self assert: (self hasElementWithId: self class cssId).! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/18/2011 11:44'!
testName

	self assert: (self hasElementWithName: self class cssId).! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/18/2011 11:47'!
testNothing! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/17/2011 17:01'!
testText

	self assert: (self hasText: 'Hello World').! !

!OrcaDomTestCase class methodsFor: 'as yet unclassified' stamp: 'hk 5/17/2011 19:45'!
requiredClasses

	 ^ OrcaWidget allSubclasses! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 11:27'!
add: aWidget

	self window add: aWidget   ! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 15:06'!
buildWindow

	self window: (OrcaPopup new source: (OrcaClientSideTestRunner blankDocumentPath)).
	self window addToWorld.! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 16:35'!
elementWithId: aString

	^ self window document getElementById value: aString! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 16:36'!
elementsWithName: aString

	^ self window document getElementsByName value: aString! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 16:36'!
elementsWithTag: anHtmlTag

	^ self window document getElementsByTagName value: anHtmlTag! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'hk 5/17/2011 19:35'!
has: aNumber elementsWithName: aString

	^ (self elementsWithName: aString) size = aNumber! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'hk 5/17/2011 19:35'!
has: aNumber elementsWithTag: anHtmlTag

	^ (self elementsWithTag: anHtmlTag) size = aNumber! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 11:39'!
hasElementWithId: aString

	^ (self elementWithId: aString) notNil! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'hk 5/17/2011 19:35'!
hasElementWithName: aString

	^ (self elementsWithName: aString) notEmpty! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 16:11'!
hasElementWithTag: anHtmlTag

	| foooo |
	foooo :=  (self elementsWithTag: anHtmlTag) notEmpty.
	self halt.
	^ foooo! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 16:27'!
hasText: aString

	^ self window find value: aString
	! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 16:06'!
runOnClientside  
	
	self buildWindow.
	^ super runOnClientside! !

!OrcaDomTestCase methodsFor: 'accessing' stamp: 'sw 5/23/2011 11:29'!
window
	^ window! !

!OrcaDomTestCase methodsFor: 'accessing' stamp: 'sw 5/23/2011 11:29'!
window: anObject
	window := anObject! !

OrcaSession subclass: #OrcaClientSideTestSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestSession methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 08:14'!
handleChannelOpened

	super handleChannelOpened.
	OrcaClientSideTestRunner signalIncomingClientConnection.! !

TestSuite subclass: #OrcaClientSideTestSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:26'!
createCollectionOfAssociationsFrom: aCollectionOfTestCases

	| collection |
	collection := OrderedCollection new.
	aCollectionOfTestCases do: [ :each |
		collection add: (each class name -> each selector) ].
	
	^ collection.! !

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:28'!
run 
	

	OrcaClientSideTestRunner ensureClientSideTestRunnerIsStarted.
	
	tests := self createCollectionOfAssociationsFrom: self tests.
	
	OrcaClientSideTestSession allInstancesDo: 
		[ :each |
			[ :aDictionary | Js Global testRunner executeTests: aDictionary ] inSession: each values: { tests }..
		].
	
	^ OrcaClientSideTestRunner waitForTestsResults! !

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/10/2011 14:53'!
run: aResult 
	"this method will be called when executing a bunch of tests (e.g. of whole classes in the class browser)"
	
	self halt.
	self tests do: [:each | 
		self changed: each.
		each run: aResult].
			! !

TestResult subclass: #OrcaTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:41'!
erroneousTestcases

	^ errors! !

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:42'!
failedTestcases

	^ failures! !

!OrcaTestResult methodsFor: 'initialization' stamp: 'hk 5/17/2011 17:02'!
initialize

	super initialize.
	failures := OrderedCollection new.! !

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:41'!
passedTestcases

	^ passed! !

Object subclass: #OrcaMock
	instanceVariableNames: 'mockedObject receivedMessages stubbedMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMock class methodsFor: 'instance creation' stamp: 'hk 5/3/2011 07:46'!
for: anObject

	^ self new mockedObject: anObject! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 09:43'!
doesNotUnderstand: aMessage

	self receivedMessages add: aMessage.
	(self stubs: aMessage)
		ifTrue: [ ^ (self stubbedMessages at: aMessage selector) value ]
		ifFalse: [ aMessage sendTo: self mockedObject ].! !

!OrcaMock methodsFor: 'initialization' stamp: 'hk 5/3/2011 09:37'!
initialize

	self
		receivedMessages: OrderedCollection new;
		stubbedMessages: Dictionary new.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject
	^ mockedObject! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject: anObject
	mockedObject := anObject! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:20'!
received: aMessage

	self assert: aMessage isSymbol.
	^ self received: aMessage atLeast: 1! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:10'!
received: aMessage atLeast: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size >= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:21'!
received: aMessage atMost: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size <= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:11'!
received: aMessage times: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size = aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 10:20'!
received: aMessage withArgs: arguments

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each |
		each selector = aMessage
		and: [ each arguments = arguments ]
		]) notEmpty! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages
	^ receivedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages: anObject
	receivedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:38'!
stub: aMessage

	self stubbedMessages at: aMessage put: nil.! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:40'!
stub: aMessage andReturn: aBlock

	self stubbedMessages at: aMessage put: aBlock.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages
	^ stubbedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages: anObject
	stubbedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:42'!
stubs: aMessage

	^ self stubbedMessages includesKey: aMessage selector! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 07:57'!
unmock

	| temp |
	temp := self mockedObject.
	self mockedObject: nil.
	self become: temp.! !

TestCase subclass: #OrcaMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock
	^ mock! !

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock: anObject
	mock := anObject! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
setUp

	self mock: (OrcaMock for: (OrderedCollection new)).! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
tearDown

	self mock: nil.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:11'!
testCleanInitialization

	self assert: self mock receivedMessages isEmpty.
	self assert: self mock stubbedMessages isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:50'!
testMessageForwarding

	self assert: (self mock stubbedMessages isEmpty).
	self mock add: true.
	self assert: self mock mockedObject size = 1! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:48'!
testMockedObject

	self assert: self mock mockedObject isCollection.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:19'!
testReceived

	self mock add: 1.
	self assert: (self mock received: #add:).
	self assert: (self mock received: #add: withArgs: { 1}).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:22'!
testReceivedAtLeast

	self deny: (self mock received: #add: atLeast: 1).
	self mock add: 1.
	self assert: (self mock received: #add: atLeast: 1).
	self deny: (self mock received: #add: atLeast: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedAtMost

	self assert: (self mock received: #add: atMost: 1).
	self mock
		add: 1;
		add: 2..
	self deny: (self mock received: #add: atMost: 1).
	self assert: (self mock received: #add: atMost: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedTimes

	self deny: (self mock received: #add: times: 1).
	self mock add: 1.
	self assert: (self mock received: #add: times: 1).
	self deny: (self mock received: #add: times: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:17'!
testStubReturnValue

	self mock stub: #add: andReturn: true.
	self assert: (self mock add: 1 = true).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:20'!
testStubReturnsNil

	self mock stub: #add:.
	self assert: ((self mock add: 1) = nil).
	self assert: self mock mockedObject isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:15'!
testStubbedMessages

	self mock stub: #add:.
	self deny: (self mock stubbedMessages isEmpty).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:47'!
testUnmock

	self mock unmock.
	self assert: self mock isCollection.! !

OrcaWidget subclass: #OrcaClientSideTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

OrcaClientSideTestRunner class
	instanceVariableNames: 'dispatcher tests testResults clientConnectionSemaphore testResultSemaphore'!

OrcaClientSideTestRunner class
	instanceVariableNames: 'dispatcher tests testResults clientConnectionSemaphore testResultSemaphore'!

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'hk 5/18/2011 14:05'!
blankDocumentPath

	^ 'file/documents/blank.html'! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
clientConnectionSemaphore
	^ clientConnectionSemaphore! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
clientConnectionSemaphore: anObject
	clientConnectionSemaphore := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
dispatcher
	^ dispatcher! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
dispatcher: anObject
	dispatcher := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:26'!
ensureClientSideTestRunnerIsStarted

	| activeSessions |
	
	self dispatcher ifNil:  [ self startDispatcher ].
		
	activeSessions := OrcaClientSideTestSession allInstances 
		select: [ :each |
			each channel notNil and: [ each channel isAlive] 
		].
		
	activeSessions	isEmpty ifTrue:
		[ self runFireFox ].
	
	
	   
	
		
	! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
isOrcaRootComponent
	
	^ true! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'sw 5/17/2011 14:32'!
maxSecondsForTesting
	
	^ 60! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
orcaSessionClass 

	 ^OrcaClientSideTestSession! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
orcaTitle
	
	^ 'Testing is fun'! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
requiredClasses
	
	^ OrcaClientSideTestCase allSubclasses add: Dictionary; yourself! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:40'!
reset

	OrcaClientSideTestSession allInstancesDo: [ :each |
		each channel ifNotNil: [ each channel  released ] ].
	
	self
		stopDispatcher;
		startDispatcher.! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:28'!
runFireFox

	"CommandShell command: 'open /Applications/Firefox.app --args http://localhost:', OrcaTestRunner testPort , '/',  OrcaTestRunner uniquePath , '; exit'"
	CommandShell command: 'open ''http://localhost:', OrcaClientSideTestRunner testPort , '/',  OrcaClientSideTestRunner uniquePath , '''; exit'.
	
	self clientConnectionSemaphore: Semaphore new.
	(self clientConnectionSemaphore waitTimeoutSeconds: self secondsToWaitForFirefox) ifTrue: [
		" the Semaphore wasn't signaled" 
		TimedOut signal: 'The Browser isn''t responding' ].! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'hk 5/18/2011 10:26'!
secondsToWaitForFirefox

	^ 60
	
		
	! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'sw 5/24/2011 08:15'!
signalIncomingClientConnection.

	self clientConnectionSemaphore ifNotNilDo: 
		[ self clientConnectionSemaphore signal ]  ! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/23/2011 15:38'!
start

	"Js Global st DEBUG: false."
	Js Global testRunner: (OrcaClientSideTestRunner new addToWorld; yourself).
	! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:27'!
startDispatcher
	
	Transcript show: 'The TestRunner Dispatcher is starting'; cr.
	self dispatcher: (OrcaDispatcher installOn: self testPort  withName: self name ).
	(OrcaDispatcher siteNamed: self name ) start.
	! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:45'!
stopDispatcher
	
	self dispatcher ifNotNil: [ | site |
		Transcript show: 'The TestRunner Dispatcher is stopping'; cr.
		self dispatcher: nil.
		(site := OrcaDispatcher siteNamed: self name) ifNotNil: [
			SwazooServer singleton removeSite: site.
			]
		].! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'hk 5/18/2011 10:26'!
testPort

	^ 8886! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 11:28'!
testResultSemaphore
	^ testResultSemaphore! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 11:28'!
testResultSemaphore: anObject
	testResultSemaphore := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 12:11'!
testResults
	^ testResults! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:35'!
testResults: anObject

	testResults := anObject.
	self testResultSemaphore signal.
	^ true! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/17/2011 16:37'!
testResultsFromString
	| result testcase |
	
	result := OrcaTestResult new.
	testcase := OrcaClientSideTestCase new; selector: #foo.
	
	(self testResults = 'pass') 
		ifTrue: [result passedTestcases add: testcase].
	(self testResults = 'error') 
		ifTrue: [result erroneousTestcases add: testcase].
	(self testResults = 'failure') 
		ifTrue: [result failedTestcases add: testcase].

	^ result

	
	! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
tests
	^ tests! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
tests: anObject
	tests := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
uniquePath

	^ 'testing'! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 08:18'!
waitForTestsResults

	self testResultSemaphore: Semaphore new.
	(self testResultSemaphore waitTimeoutSeconds: self maxSecondsForTesting)
	 	ifTrue: [ TimedOut signal: 'Browser doesn''t answer' ]
		ifFalse: [ ^ self testResultsFromString ]

	! !

!OrcaClientSideTestRunner methodsFor: 'running' stamp: 'sw 5/24/2011 09:13'!
executeTests: aCollectionOfTests
	
	| results |
	results := OrderedCollection new.
	
	aCollectionOfTests do: [ :eachAssociation |      
		results add: (self performTest: eachAssociation )				
	].

	self sendResults: results.
	self add: (OrcaText new text: '<br/>Results have been sent.').
	self halt.! !

!OrcaClientSideTestRunner methodsFor: 'initialization' stamp: 'sw 5/23/2011 11:19'!
initialize

	super initialize.
	self
		add: (OrcaHeading new text: 'Test Runner')
	! !

!OrcaClientSideTestRunner methodsFor: 'running' stamp: 'sw 5/23/2011 13:09'!
performTest: anAssociation 
	
	| result testcase |
	testcase := (Js instanceFromClassNamed: anAssociation key) setTestSelector: anAssociation value.
	result := testcase runOnClientside.

	self add: (OrcaText new text: '<br/>' , anAssociation key, ' >> ', anAssociation value, ' with result: ', (self resultStringFor: result)   ).  
	
	^ result! !

!OrcaClientSideTestRunner methodsFor: 'disposable' stamp: 'hk 5/17/2011 19:47'!
resultStringFor: aTestResult

	| resultString |
	
	resultString:= 'pass'.	
	aTestResult hasFailures ifTrue: [
		resultString := 'failure'].
	aTestResult hasErrors ifTrue: [
		resultString := 'error'].
	^ resultString
	  
	! !

!OrcaClientSideTestRunner methodsFor: 'running' stamp: 'sw 5/17/2011 15:33'!
sendResults: results

	[ :testResults | OrcaClientSideTestRunner testResults: testResults ] onServer value: (self resultStringFor: results first).
	! !

OrcaWidget subclass: #OrcaPopup
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaPopup class methodsFor: 'configuration' stamp: 'hk 5/18/2011 16:05'!
htmlElementType

	^ 'window'! !

!OrcaPopup methodsFor: 'rendering' stamp: 'hk 5/18/2011 15:58'!
add: anObject

	self children add: anObject.
	self isVisible ifTrue: [ self append: anObject ].
	^ anObject! !

!OrcaPopup methodsFor: 'rendering' stamp: 'sw 5/23/2011 14:23'!
append: anObject

	self body appendChild value: anObject node.! !

!OrcaPopup methodsFor: 'rendering' stamp: 'sw 5/23/2011 11:37'!
body
	
	^ self window document body ! !

!OrcaPopup methodsFor: 'rendering' stamp: 'sw 5/23/2011 16:36'!
document
	
	^ self window document! !

!OrcaPopup methodsFor: 'initialization' stamp: 'hk 5/18/2011 15:50'!
initialize

	super initialize.
	self cssClass: 'pseudoElement'.! !

!OrcaPopup methodsFor: '*Orca-Testing' stamp: 'hk 5/18/2011 15:56'!
isVisible

	^ self window notNil! !

!OrcaPopup methodsFor: 'initialization' stamp: 'sw 5/23/2011 15:59'!
onLoad

	self window: (Js Global window open value: self source ).
	self children do: [ :each | self append: each ].! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 16:05'!
source

	^ self node src! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 16:05'!
source: aUrl

	self node src: aUrl.! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 15:50'!
window
	^ window! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 15:50'!
window: anObject
	window := anObject! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/17/2011 19:37'!
hasChild: aWidget

	^ self children includes: aWidget! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/17/2011 19:39'!
hasChildOfClass: aClass

	^ self children
		detect: [ :each | each class = aClass ]
		ifFound: [ true ]
		ifNone: [ false ]! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/17/2011 19:40'!
isVisible

	^ (self node style display = 'none') not! !
